<?php

/**
 * punto_venta actions.
 *
 * @package    cartera
 * @subpackage punto_venta
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class punto_ventaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_PUNTO_VENTA',
        'INTERCEROS',
        'IN_ESPACIO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'INTERCEROS,LEFT' =>
        array(
            'administrador-id_mae_ter' => 'CA_PUNTO_VENTA'
        ),
        'IN_ESPACIO,LEFT' =>
        array(
            'id_espacio' => 'CA_PUNTO_VENTA'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_PUNTO_VENTA' =>
        array(
            'id_punto_venta' => 'id_punto_venta',
            'nombre' => 'nombre',
            'descripcion' => 'descripcion',
            'estado' => 'estado',
            'abreviatura' => 'abreviatura',
            'administrador' => 'administrador',
            'encabezado' => 'encabezado',
            'pie_pagina' => 'pie_pagina',
            'es_pos' => 'es_pos',
            'enviar_email' => 'enviar_email',
            'aplica_cuenta' => 'aplica_cuenta',
            'tipo_impresion' => 'tipo_impresion',
            'aplica_inventario' => 'aplica_inventario',
            'id_cen_op' => 'id_cen_op',
            'id_concepto_movimiento' => 'id_concepto_movimiento',
            'id_mae_ter' => 'id_mae_ter',
            'id_tipo_almacenamiento' => 'id_tipo_almacenamiento',
            'id_espacio' => 'id_espacio',
            'id_ts_td' => 'id_ts_td',
            'id_tipo_factura' => 'id_tipo_factura',
            'aplica_bloqueo' => 'aplica_bloqueo',
            'aplica_bloqueo_nc' => 'aplica_bloqueo_nc'
        ),
        'INTERCEROS' =>
        array(
            'num_doc' => 'num_doc',
            'razon_soc' => 'razon_soc',
            'num_doc,||, - ,||,razon_soc' => 'nombre_admin'
        ),
        'IN_ESPACIO' =>
        array(
            'id_estructura' => 'id_estructura'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_PUNTO_VENTA' => array(
            'id_punto_venta, a' => array('!=' => array(-1)),
            'id_punto_venta, b' => array('=' => array('id_punto_venta')),
            'estado' => array('=' => array('estado')),
            'es_pos' => array('=' => array('es_pos')),
            'rownum, start' => array('>' => array('_startRow')),
            'rownum, end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
        'CA_PUNTO_VENTA' =>
        array(
            'nombre' => array('LIKEALLPLUS' => array('input', '%')),
            'descripcion' => array('LIKEALLPLUS' => array('input', '%'))
        )
    ); // filtros de condicion or
    protected $fields_orderBy = array(
        'nombre'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_punto_venta'; //identificador de la tabla
    protected $id_names = array('id_punto_venta'); //llave primaria
    protected $field_names = array('nombre', 'descripcion', 'estado', 'abreviatura', 'administrador', 'encabezado',
        'pie_pagina', 'es_pos', 'enviar_email', 'aplica_cuenta', 'tipo_impresion',
        'aplica_inventario', 'id_cen_op', 'id_concepto_movimiento', 'id_mae_ter', 'id_tipo_almacenamiento',
        'id_espacio', 'id_ts_td', 'aplica_bloqueo', 'aplica_bloqueo_nc'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CA_PUNTO_VENTA'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
//    protected $en_mayuscula = false; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_punto_venta'; //identificador unico de la tabla

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */

    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            /**
             * Reemplazo de caracteres HTML - 20141104
             */
            $encabezado = $request['encabezado'];

            $encabezado = str_replace("&lt;", "<", $encabezado);
            $encabezado = str_replace("&gt;", ">", $encabezado);
            $encabezado = str_replace("&#039;", "'", $encabezado);
            $encabezado = str_replace("&nbsp;", " ", $encabezado);

            $request['encabezado'] = $encabezado;


            $pie_pagina = $request['pie_pagina'];

            $pie_pagina = str_replace("&lt;", "<", $pie_pagina);
            $pie_pagina = str_replace("&gt;", ">", $pie_pagina);
            $pie_pagina = str_replace("&#039;", "'", $pie_pagina);
            $pie_pagina = str_replace("&nbsp;", " ", $pie_pagina);

            $request['pie_pagina'] = $pie_pagina;
        }

        //accion update
        if ($Action == "UPDATE") {

            /**
             * Reemplazo de caracteres HTML - 20141104
             */
            $encabezado = $request['encabezado'];

            $encabezado = str_replace("&lt;", "<", $encabezado);
            $encabezado = str_replace("&gt;", ">", $encabezado);
            $encabezado = str_replace("&#039;", "'", $encabezado);
            $encabezado = str_replace("&nbsp;", " ", $encabezado);

            $request['encabezado'] = $encabezado;


            $pie_pagina = $request['pie_pagina'];

            $pie_pagina = str_replace("&lt;", "<", $pie_pagina);
            $pie_pagina = str_replace("&gt;", ">", $pie_pagina);
            $pie_pagina = str_replace("&#039;", "'", $pie_pagina);
            $pie_pagina = str_replace("&nbsp;", " ", $pie_pagina);

            $request['pie_pagina'] = $pie_pagina;
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
